/*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania I - Podr
 *
 * Autor programu: Wojciech Mruczkiewicz
 */

#include <cstdio>
#include <vector>
#include <utility>
using namespace std;

#define MAX_N 100
#define MAX_T 1001

vector< pair<int, int> > G[MAX_N];
int T[MAX_N][MAX_T];
int P[MAX_N][MAX_T];
int n, p, k, t;

bool solve();
void print(int n, int t);
int count(int n, int t);

int main() {
	int d;

	scanf("%d", &d);

	while (d--) {
		int m;
		scanf("%d%d", &n, &m);
		
		for (int i = 0; i < n; i++)
			G[i].clear();

		for (int i = 0; i < m; i++) {
			int a, b, c;
			scanf("%d%d%d", &a, &b, &c);
			--a; --b;
			G[a].push_back(make_pair(b, c));
			G[b].push_back(make_pair(a, c));
		}
		scanf("%d", &t);
		scanf("%d%d", &p, &k);
		--p; --k;

		if (solve()) {
			printf("%d\n", count(k, t));
			print(k, t);
		} else
			printf("BRAK TRASY");
		printf("\n");
	}

	return 0;
}

bool solve() {
	for (int i = 0; i < n; i++)
		for (int j = 0; j <= t; j++)
			T[i][j] = 0;
	T[p][0] = -1;

	for (int j = 0; j <= t; j++) {
		for (int i = 0; i < n; i++) {
			if (T[i][j]) {
				for (int k = 0; k < G[i].size(); k++) {
					if (j + G[i][k].second <= t) {
						T[G[i][k].first][j + G[i][k].second] = G[i][k].second;
						P[G[i][k].first][j + G[i][k].second] = i;
					}
				}
			}
		}
	}
	if (T[k][t])
		return true;
	return false;
}

void print(int n, int t) {
	if (T[n][t] == -1)
		printf("%d", n + 1);
	else {
		print(P[n][t], t - T[n][t]);
		printf(" %d", n + 1);
	}
}

int count(int n, int t) {
	if (T[n][t] == -1)
		return 1;
	return count(P[n][t], t - T[n][t]) + 1;
}

